<?php

/**
 * Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.2 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: Plugin.php,v 1.2 2005/04/15 13:07:46 mike Exp $
 */

/** 
 * Gadget_Plugin
 *
 * @package     Gadget
 * @since       1.0
 */
class Gadget_Plugin
{
    /**
     * Constructor
     * 
     * @access  public
     * @param   mixed
     */
    function Gadget_Plugin($args)
    {
        $this->init($args);
    }
    
    /**
     * Init
     * 
     * @access  protected
     * @return  void
     * @param   mixed
     */
    function init($args)
    {
        //
    }
    
    /**
     * Singleton
     * 
     * @static
     * @access  public
     * @return  object
     * @param   string
     * @param   string
     */
    function &singleton($type, $plugin)
    {
        list($class, $file, $param) = Gadget_Plugin::lookup($type, $plugin);
        return isset($class) ? Gadget::persistentObject($class, $param, $file) : null;
    }
    
    /**
     * Configure a Plugin
     * 
     * @static
     * @access  public
     * @return  void
     * @param   string
     * @param   mixed
     */
    function configure($type, $plugin, $params)
    {
        $GLOBALS['_Gadget'][strToUpper($type)]['Config'][strToLower($plugin)] = $params;
    }
    
    /**
     * Register Plugin
     * 
     * @access  public
     * @return  void
     * @param   string
     * @param   string
     * @param   string
     */
    function register($type, $plugin, $class, $file = null)
    {
        $reg = &$GLOBALS['_Gadget'][strToUpper($type)]['Registry'];
        $reg[strToLower($plugin)]['userdef'] = array($class, $file);
    }
    
    /**
     * Lookup Plugin
     * 
     * @access  public
     * @return  array
     * @param   string
     * @param   string
     */
    function lookup($type, $plugin)
    {
        $typ = strToUpper($type);
        $plg = strToLower($plugin);
        $reg = &$GLOBALS['_Gadget'][$type]['Registry'][$plg];
        $cfg = &$GLOBALS['_Gadget'][$type]['Config'][$plg];
        $plg = count($reg['userdef']) ? 'userdef' : 'default';
        return array($reg[$plg][0], $reg[$plg][1], $cfg);
    }
}
?>
