<?php

/**
 * GWDK - Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Provider
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.3 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: Rights.php,v 1.3 2005/04/15 13:07:47 mike Exp $
 */

/**
 * Requires Gadget_Provider
 */
class_exists('Gadget_Provider') or require_once 'Gadget/Povider.php';

/**
 * Gadget_Provider_Rights
 *
 * Gadget's default rights provider
 * 
 * @package     Gadget
 * @subpackage  Gadget_Provider
 * @since       1.0
 */
class Gadget_Provider_Rights extends Gadget_Provider
{
    var $provider = PROVIDER_RIGHTS;
    
    /**
     * Get
     * 
     * @access  public
     * @return  mixed
     */
    function get()
    {
        return Gadget::currentUser('rights');
    }
    
    /**
     * Set
     * 
     * @access  public
     * @return  mixed
     * @param   int
     */
    function set($rights)
    {
        $user = Gadget::getCurrentUser(true);
        $user->rights = $rights;
        return $user->update();
    }
    
}

?>
