<?php

/**
 * GWDK - Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Service
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.2 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: Rights.php,v 1.2 2005/04/15 13:07:47 mike Exp $
 */

/**
 * Requires Gadget_Service
 */
class_exists('Gadget_Service') or require_once 'Gadget/Service.php';

/**
 * Gadget_Service_Rights
 *
 * Gadget's default rights service.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Service
 * @since       1.0
 */
class Gadget_Service_Rights extends Gadget_Service
{
    var $service = SERVICE_RIGHTS;
    var $condition;
    
    /**
     * Execute
     * 
     * @access  protected
     * @return  bool
     * @param   int
     */
    function execute($rights)
    {
        $has = Gadget::callProviderGet(PROVIDER_RIGHTS);
        $this->condition = $rights .' <= '. (int) $has;
        return $rights <= (int) $has;
    }
    
    /**
     * On Success
     * 
     * @access  protected
     * @return  bool true
     */
    function onSuccess()
    {
        return parent::onSuccess($this->condition);
    }
    
    /**
     * On Failure
     * 
     * @access  protected
     * @return  bool false
     */
    function onFailure()
    {
        return parent::onFailure($this->condition);
    }
    
}

?>
