<?php

/**
 * GWDK - Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Tree
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.2 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: XML.php,v 1.2 2005/04/15 13:07:47 mike Exp $
 */

class_exists('Gadget_Tree_Serializer') or require_once 'Gadget/Tree/Serializer.php';

/** 
 * Gadget_Tree_Serializer_XML
 * 
 * @package     Gadget
 * @subpackage  Gadget_Tree
 * @since       1.0
 */
class Gadget_Tree_Serializer_XML extends Gadget_Tree_Serializer
{
    /**
     * Encoding
     * 
     * @var string
     */
    var $encoding = 'iso-8859-1';
    
    /**
     * On Start
     * 
     * @access  protected
     * @return  string
     */
    function onStart()
    {
        return '<?xml version="1.0" encoding="'. $this->encoding .'"?>'. "\n";
    }
    
    /**
     * On End
     * 
     * @access  protected
     * @return  string
     */
    function onEnd()
    {
        return "\n";
    }
    
    /**
     * On Node Enter
     * 
     * @access  protected
     * @return  string
     */
    function onNodeEnter(&$node)
    {
        if ($node->isTextNode) {
            return $node->data;
        }
        
        $pre = '<';
        if ($node->namespace) {
            $pre .= $node->namespace .':';
        }
        
        return $pre . $node->name . $node->attributeString()
            . ($node->childs ? '>' : '/>');
    }
    
    /**
     * On Node Exit
     * 
     * @access  protected
     * @return  string
     */
    function onNodeExit(&$node)
    {
        if (!$node->childs) {
            return '';
        }

        if (strlen($node->namespace)) {
            return '</'. $node->namespace .':'. $node->name .'>';
        }

        return '</'. $node->name .'>';
    }
}

?>
