<?php

/**
 * GWDK - Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Widget
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.2 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: Menu.php,v 1.2 2005/04/15 13:07:47 mike Exp $
 */

/**
 * Requires Gadget_Widget
 */
class_exists('Gadget_Widget') or require_once 'Gadget/Widget.php';

/**
 * Menu
 *
 * Menu widget.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Widget
 * @since       1.0
 */
class Menu extends Gadget_Widget
{
    var $template = 'Menu.html';
    var $aggregateFormatter = true;
    
    var $sections = array();
    
    function &addSection($title, $href = '', $links = array())
    {
        $section = &new MenuSection($title, $href, $links);
        $this->sections[$title] = &$section;
        return $section;
    }
    
    function &getSection($title)
    {
        return $this->sections[$title];
    }
}

/**
 * MenuSection
 *
 * Menu Section, having a (maybe linked) header, containing actual menu links.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Widget
 * @since       1.0
 */
class MenuSection
{
    var $links = array();
    var $text;
    var $href;
    
    function MenuSection($text, $href = '', $links = array())
    {
        $this->text = $text;
        $this->href = $href;
        foreach ($links as $text => $href) {
            $this->addLink($text, $href);
        }
    }
    
    function &addLink($text, $href)
    {
        $this->links[] = (object) array('text' => $text, 'href' => $href);
    }
}

?>